<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelRatePlanSpecialNoteText ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelRatePlanSpecialNoteText extends AbstractStructArrayBase
{
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelRatePlanSpecialNoteText[]
     */
    public $Text;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     * @uses ArrayOfJPSOAP_HotelRatePlanSpecialNoteText::setText()
     * @param \StructType\JPSOAP_HotelRatePlanSpecialNoteText[] $text
     */
    public function __construct(array $text = array())
    {
        $this
            ->setText($text);
    }
    /**
     * Get Text value
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText[]|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * This method is responsible for validating the values passed to the setText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setText method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextForArrayConstraintsFromSetText(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem instanceof \StructType\JPSOAP_HotelRatePlanSpecialNoteText) {
                $invalidValues[] = is_object($arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem) ? get_class($arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem), var_export($arrayOfJPSOAP_HotelRatePlanSpecialNoteTextTextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Text property can only contain items of type \StructType\JPSOAP_HotelRatePlanSpecialNoteText, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Text value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanSpecialNoteText[] $text
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     */
    public function setText(array $text = array())
    {
        // validation for constraint: array
        if ('' !== ($textArrayErrorMessage = self::validateTextForArrayConstraintsFromSetText($text))) {
            throw new \InvalidArgumentException($textArrayErrorMessage, __LINE__);
        }
        $this->Text = $text;
        return $this;
    }
    /**
     * Add item to Text value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelRatePlanSpecialNoteText $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelRatePlanSpecialNoteText
     */
    public function addToText(\StructType\JPSOAP_HotelRatePlanSpecialNoteText $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelRatePlanSpecialNoteText) {
            throw new \InvalidArgumentException(sprintf('The Text property can only contain items of type \StructType\JPSOAP_HotelRatePlanSpecialNoteText, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Text[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelRatePlanSpecialNoteText|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Text
     */
    public function getAttributeName()
    {
        return 'Text';
    }
}
